/*
(C) 1.10.1999  Petr Latovika

vygeneruje vechny magick tverce velikosti 4 x 4
vsledek se vypisuje na standardn vstup

*/

#include <stdio.h>
#include <stdlib.h>

typedef struct {
	int l,r;
} Tdvojice;

int A[16],A2[16],//vsledn tverec
		S[4],//stedy
		pocR[6];//poet dvojic v R[i]
Tdvojice R[6][8],//rozklady 6 sel na dvojice
				 *T[6];//ukazatel na dvojice na okrajch tverce
int B[17];//1=u bylo slo vepsno do tverce
int X[6];
long pocreseni,pocctvrt;

int min(int a,int b){ return a>b ? b:a; }
int max(int a,int b){ return a<b ? b:a; }

//--------------------------------------------------------------------
//vytiskne een A
void tisk()
{
 static const int k2[]={15,13,14,12,7,5,6,4,11,9,10,8,3,1,2,0};
 int *u,*v, i,j;
//vytvo 2.een
	for(i=0;i<16;i++) A2[k2[i]]=A[i];
//tisk
	u=A; v=A2;
	for(i=0;i<4;i++){
		putchar('\n');
		for(j=0;j<4;j++) printf("%3d",*u++);
		printf("   ");
		for(j=0;j<4;j++) printf("%3d",*v++);
	}
	pocreseni+=2;
	if(A[0]+A[1]+A[4]+A[5]==34){
		printf("  !");
		pocctvrt+=2;
	}
	putchar('\n');

#ifdef DEBUG
  int sum;
//test dk
	u=A;
	for(i=0;i<4;i++){
		sum=34;
		for(j=0;j<4;j++) sum-=*u++;
		if(sum) exit(1);
	}
//test sloupc
	for(i=0;i<4;i++){
		sum=34;
		for(u=A+i; u<A+16; u+=4) sum-=*u;
		if(sum) exit(1);
	}
//test hlopek
	if(A[0]+A[5]+A[10]+A[15]!=34 || A[3]+A[6]+A[9]+A[12]!=34) exit(1);
#endif
}

//--------------------------------------------------------------------
void vysledek(int s,int rohy)
{
 static const Tdvojice p[4]={{1,13},{2,14},{4,7},{8,11}};
 static const int ks[3][3]={{2,3,1},{1,3,2},{1,2,3}};
 static const int kh[3][4]={{5,4,3,2},{5,4,1,0},{3,2,1,0}};
 int *us,*uh;
 int i,sum,rot1,rot2,x;

	us=(int *)ks[s];
	uh=(int *)kh[s];
//stedy
	A[5]=*S;
	A[6]=S[us[0]];
	A[9]=S[us[1]];
	A[10]=S[us[2]];
//rohy
	A[3]=T[s*2]->r;
	A[12]=T[s*2]->l;
	if((s^rohy)&1) A[0]=T[s*2+1]->r, A[15]=T[s*2+1]->l;
	else A[0]=T[s*2+1]->l, A[15]=T[s*2+1]->r;
//hrany
	for(i=0;i<4;i++) A[p[i].l]=T[uh[i]]->l, A[p[i].r]=T[uh[i]]->r;
//prohozen protilehlch sel na hranch
//nejdve prostedn sloupce, pak dky
	sum=A[0]+A[3];
	for(i=0;i<4;i+=2){
		rot1=rot2=0;
		if(A[p[i].l] + A[p[i+1].r] ==sum) rot1=1; else
		if(A[p[i].r] + A[p[i+1].l] ==sum) rot2=1; else
		if(A[p[i].l] + A[p[i+1].l] ==sum) rot1=rot2=1;
		if(rot1) x=A[p[i].l], A[p[i].l]=A[p[i].r], A[p[i].r]=x;
		if(rot2) x=A[p[i+1].l], A[p[i+1].l]=A[p[i+1].r], A[p[i+1].r]=x;
		sum=A[0]+A[12];
	}
	tisk();
	if(A[1]+A[2]==17){
		x=A[1], A[1]=A[13], A[13]=x, x=A[2], A[2]=A[14], A[14]=x;
		tisk();
	}else if(A[4]+A[8]==17){
		x=A[4], A[4]=A[7], A[7]=x, x=A[8], A[8]=A[11], A[11]=x;
		tisk();
	}
}

//--------------------------------------------------------------------
void okraje()
{
 int j,o,s,o1,o2;
 int c1,c2;

//vytvo pole X
	X[0]=T[0]->l+T[1]->l;
	X[1]=T[0]->l+T[1]->r;
	X[2]=T[2]->l+T[3]->l;
	X[3]=T[2]->l+T[3]->r;
	X[4]=T[4]->l+T[5]->l;
	X[5]=T[4]->l+T[5]->r;
	for(j=0;j<6;j++) if(X[j]>17) X[j]=34-X[j];
//3 monosti vzjemn polohy 4 stedovch sel
	for(s=0;s<6;s+=2){
		c1=X[s], c2=X[s+1];
		o2=(( o1=(s+2)%6 )+2)%6;
		//2 monosti pro rohy
		for(j=0;j<2;j++){
			if(X[o1]==c1 || X[o1+1]==c1){
				if(X[o2]==c2 || X[o2+1]==c2){
					vysledek(s/2,j);
				}
			}
			o=o1, o1=o2, o2=o;
		}
	}
}


//z pole R vybere 6 rznch dvojic do pole T a zavol okraje()
void komb1(int s)
{
 int i;
 Tdvojice *u;

	for(i=0;i<pocR[s];i++){
		u=&R[s][i];
		if(!B[u->l] && !B[u->r]){
			B[u->l]=B[u->r]=1;
			T[s]=u;
			if(s<5) komb1(s+1);
			else okraje();
			B[u->l]=B[u->r]=0;
		}
	}
}


//do R[i] vygeneruje dvojice se soutem suma
void generuj(int i,int suma)
{
 int j,k;
 Tdvojice *u=R[i];

	pocR[i]=0;
	for(j=max(1,suma-16),k=suma-j; j<k; j++,k--)
		if(!B[j] && !B[k]){
			u->l=j;
			u->r=k;
			u++;
			pocR[i]++;
		}
}


//vytiskne tverce se stedovmi sly z pole S
void ctverec()
{
 int i=0,j;

	for(j=0;j<3;j++) B[S[j]]=1;
	for(j=1;j<=3;j++){
		generuj(i++,S[0]+S[j]);
		generuj(i++,34-S[0]-S[j]);
	}
	komb1(0);
	for(j=0;j<3;j++) B[S[j]]=0;
}


//do pole S tvo rostouc posloupnosti 4 sel se soutem suma
void rozklad(int suma,int prvni,int i)
{
 int j;

	if(i<3){
		for(j=prvni; j<=min(16,suma/2); j++){
			S[i]=j;
			rozklad(suma-j,j+1,i+1);
		}
	}else{
		if(suma>=prvni && suma<=16){
			S[i]=suma;
			ctverec();
		}
	}
}

int main()
{
 puts("Magicke ctverce 4x4");
 rozklad(34,1,0);
 printf("\nPocet reseni: %d\n",pocreseni);
 printf("Se stejnymi soucty ve ctvrtinach: %d\n\n",pocctvrt);
 return 0;
}
